local pr = require ('push-rectangle')

local polygonPoints = {
    75, 125,
    125, 125,
    150, 150,
    150, 250,
    125, 275,
     75, 275,
     50, 250,
     50, 150,
}


local linePoints = {
    100, 400,
    700, 200,
}

local polygon = pr.newPolygon (polygonPoints)
local line = pr.newline (linePoints)


function love.update(dt)
	
	local x1 = 400-400*math.cos (love.timer.getTime()/5)
	local y1 = 300+300*math.sin (love.timer.getTime()/5)
	local x2 = 400+400*math.cos (love.timer.getTime()/5)
	local y2 = 300-300*math.sin (love.timer.getTime()/5)
	
	line[1] = x1
	line[2] = y1
	line[3] = x2
	line[4] = y2
	line = pr.newline (linePoints)
	
	polygon.x, polygon.y = pr.push (polygon, line, polygon.x, polygon.y)
end

function love.draw()
    love.graphics.setColor(1, 1, 1)
    love.graphics.setLineWidth(2.0)
		love.graphics.push()
			love.graphics.translate(polygon.x, polygon.y)
			if polygon.collision then
				love.graphics.setColor(1, 1, 0)
			end
			love.graphics.polygon('line', polygon)
			if polygon.force then
				love.graphics.setColor(0.5, 0, 0)
				love.graphics.polygon('fill', polygon)
				
				love.graphics.setColor(1, 0, 0)
				love.graphics.line (polygon.force)
				love.graphics.setColor(1, 1, 0)
				love.graphics.circle('line', polygon[polygon.index], polygon[polygon.index+1], 12)
			end
		love.graphics.pop()

    love.graphics.setColor(1, 0, 0)
    love.graphics.line(line)

    love.graphics.setColor(1, 1, 0, 1)
    love.graphics.circle('fill', line[1], line[2], 4.0)
    love.graphics.circle('fill', line[3], line[4], 4.0)
end


function love.mousemoved(mx, my)
	local targetX = mx-polygon.w/2
	local targetY = my-polygon.h/2
	polygon.x, polygon.y = pr.push (polygon, line, targetX, targetY)
end




function love.keypressed(key)
    if key == 'escape' then
        love.event.quit()
    end
end